/*
 * arch/arm/mach-dmw/css/config.c - cordless configuration interface to user space
 *
 * Using netlink, a socket interface to Linux user space is implemented that
 * allows sending configuration messages between user space and cordless.
 * The Scorpion/Anyline configuration menu is invoked through this interface.
 *
 * Copyright (C) 2007 NXP Semiconductors
 * Copyright (C) 2008 - 2011 DSP Group Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "coma-service.h"

#define SERVICE_NAME		"coma-config"
#define SERVICE_ID		COMA_SERVICE_CONFIG
#define NETLINK_ID		NETLINK_CONFIG
#define NETLINK_CFIFO_SIZE	10240

#include "netlink.c"

void config_service_init(void)
{
	netlink_init();
}

void config_service_exit(void)
{
	netlink_exit();
}
