#ifndef DMW96_CIU_H
#define DMW96_CIU_H

// CIU register set

#define CIU_EN 		   	0x0000
#define CIU_INTRC 		0x0004
#define CIU_INIT_CTRL 	0x0008
#define CIU_CTLAL 		0x000c
#define CIU_CTLAH 		0x0010
#define CIU_CTLBL 		0x0014
#define CIU_CTLBH 		0x0018
#define CIU_INT1L 		0x001c
#define CIU_INT1H 		0x0020
#define CIU_INT2L 		0x0024
#define CIU_INT2H 		0x0028
#define CIU_HSIZE 		0x002c
#define CIU_VSIZE 		0x0030
#define CIU_HWINDOW 	0x0034
#define CIU_VWINDOW 	0x0038
#define CIU_SHSIZE 		0x003c
#define CIU_SVSIZE 		0x0040
#define CIU_SWINDOW 	0x0044
#define CIU_STATA 		0x0048
#define CIU_STATBL 		0x004c
#define CIU_STATBH 		0x0050
#define CIU_STATCL 		0x0054
#define CIU_STATCH 		0x0058
#define DMA_CNTL 		0x005c
#define DFLOW_CTRL 		0x0060
#define YDMA_ADDR1L 	0x0080
#define YDMA_ADDR1H 	0x0084
#define YDMA_ADDR2L 	0x0088
#define YDMA_ADDR2H 	0x008c
#define YDMA_ADDR3L 	0x0090
#define YDMA_ADDR3H 	0x0094
#define YDMA_ADDR4L 	0x0098
#define YDMA_ADDR4H 	0x009c
#define YDMA_ADDR5L 	0x00a0
#define YDMA_ADDR5H 	0x00a4
#define YDMA_ADDR6L 	0x00a8
#define YDMA_ADDR6H 	0x00ac
#define YDMA_ADDR7L 	0x00b0
#define YDMA_ADDR7H 	0x00b4
#define YDMA_ADDR8L 	0x00b8
#define YDMA_ADDR8H 	0x00bc
#define YDMA_LOFFSET1 	0x00c0
#define YDMA_LOFFSET2 	0x00c4
#define YDMA_LOFFSET3 	0x00c8
#define YDMA_LOFFSET4 	0x00cc
#define YDMA_LOFFSET5 	0x00d0
#define YDMA_LOFFSET6 	0x00d4
#define YDMA_LOFFSET7 	0x00d8
#define YDMA_LOFFSET8 	0x00dc
#define YDMA_BLK_LEN 	0x00e0
#define UDMA_ADDR1L 	0x0100
#define UDMA_ADDR1H 	0x0104
#define UDMA_ADDR2L 	0x0108
#define UDMA_ADDR2H 	0x010c
#define UDMA_ADDR3L 	0x0110
#define UDMA_ADDR3H 	0x0114
#define UDMA_ADDR4L 	0x0118
#define UDMA_ADDR4H 	0x011c
#define UDMA_ADDR5L 	0x0120
#define UDMA_ADDR5H 	0x0124
#define UDMA_ADDR6L 	0x0128
#define UDMA_ADDR6H 	0x012c
#define UDMA_ADDR7L 	0x0130
#define UDMA_ADDR7H 	0x0134
#define UDMA_ADDR8L 	0x0138
#define UDMA_ADDR8H 	0x013c
#define UDMA_LOFFSET1 	0x0140
#define UDMA_LOFFSET2 	0x0144
#define UDMA_LOFFSET3 	0x0148
#define UDMA_LOFFSET4 	0x014c
#define UDMA_LOFFSET5 	0x0150
#define UDMA_LOFFSET6 	0x0154
#define UDMA_LOFFSET7 	0x0158
#define UDMA_LOFFSET8 	0x015c
#define UDMA_BLK_LEN 	0x0160
#define SYDMA_ADDR1L 	0x0180
#define SYDMA_ADDR1H 	0x0184
#define SYDMA_ADDR2L 	0x0188
#define SYDMA_ADDR2H 	0x018c
#define SYDMA_ADDR3L 	0x0190
#define SYDMA_ADDR3H 	0x0194
#define SYDMA_ADDR4L 	0x0198
#define SYDMA_ADDR4H 	0x019c
#define SYDMA_LOFFSET1 0x01a0
#define SYDMA_LOFFSET2 0x01a4
#define SYDMA_LOFFSET3 0x01a8
#define SYDMA_LOFFSET4 0x01ac
#define SYDMA_BLK_LEN 	0x01b0
#define SUDMA_ADDR1L 	0x0200
#define SUDMA_ADDR1H 	0x0204
#define SUDMA_ADDR2L 	0x0208
#define SUDMA_ADDR2H 	0x020c
#define SUDMA_ADDR3L 	0x0210
#define SUDMA_ADDR3H 	0x0214
#define SUDMA_ADDR4L 	0x0218
#define SUDMA_ADDR4H 	0x021c
#define SUDMA_LOFFSET1 0x0220
#define SUDMA_LOFFSET2 0x0224
#define SUDMA_LOFFSET3 0x0228
#define SUDMA_LOFFSET4 0x022c
#define SUDMA_BLK_LEN 	0x0230
#define PYDMA_ADDR1L 	0x0280
#define PYDMA_ADDR1H 	0x0284
#define PYDMA_ADDR2L 	0x0288
#define PYDMA_ADDR2H 	0x028c
#define PYDMA_ADDR3L 	0x0290
#define PYDMA_ADDR3H 	0x0294
#define PYDMA_ADDR4L 	0x0298
#define PYDMA_ADDR4H 	0x029c
#define PYDMA_LOFFSET1 0x02a0
#define PYDMA_LOFFSET2 0x02a4
#define PYDMA_LOFFSET3 0x02a8
#define PYDMA_LOFFSET4 0x02ac
#define PYDMA_BLK_LEN 	0x02b0
#define PUDMA_ADDR1L 	0x0300
#define PUDMA_ADDR1H 	0x0304
#define PUDMA_ADDR2L 	0x0308
#define PUDMA_ADDR2H 	0x030c
#define PUDMA_ADDR3L 	0x0310
#define PUDMA_ADDR3H 	0x0314
#define PUDMA_ADDR4L 	0x0318
#define PUDMA_ADDR4H 	0x031c
#define PUDMA_LOFFSET1 0x0320
#define PUDMA_LOFFSET2 0x0324
#define PUDMA_LOFFSET3 0x0328
#define PUDMA_LOFFSET4 0x032c
#define PUDMA_BLK_LEN 	0x0330
#define MIPI_CONTROL 	0x0340


#endif //#ifndef DMW96_CIU_H
