#ifndef __OSDM_REGS_OFFSET_H
#define __OSDM_REGS_OFFSET_H

#define OSDM_CONFIG	    0x000
#define INTR_STATUS	    0x004
#define INTR_MASK	    0x008
#define INTR_CAUSE	    0x00C
#define INTR_CLEAR	    0x010
#define DMA_ERROR	    0x014
#define DISPLAY_DIM	    0x018
#define DISPLAY_BGC	    0x01C

#define VIDEO0_CONFIG	0x020
#define VIDEO0_POS	    0x024
#define VIDEO0_DIM	    0x028
#define VIDEO0_BCSH	    0x02C
#define VIDEO0_TPOS	    0x030
#define VIDEO0_TDIM	    0x034
#define VIDEO0_TPIXEL	0x038
#define VIDEO0_ALCK	    0x03C
#define VIDEO0_YUVLIM	0x040

#define VIDEO1_CONFIG	0x050
#define VIDEO1_POS	    0x054
#define VIDEO1_DIM	    0x058
#define VIDEO1_BCSH	    0x05C
#define VIDEO1_TPOS	    0x060
#define VIDEO1_TDIM	    0x064
#define VIDEO1_TPIXEL	0x068
#define VIDEO1_ALCK	    0x06C
#define VIDEO1_YUVLIM	0x070

#define OSD0_CONFIG	    0x080
#define OSD0_POS	    0x084
#define OSD0_DIM	    0x088
#define OSD0_TPOS	    0x08C
#define OSD0_TDIM	    0x090
#define OSD0_TPIXEL	    0x094
#define OSD0_ALCK	    0x098

#define OSD1_CONFIG	    0x0A0
#define OSD1_POS	    0x0A4
#define OSD1_DIM	    0x0A8
#define OSD1_TPOS	    0x0AC
#define OSD1_TDIM	    0x0B0
#define OSD1_TPIXEL	    0x0B4
#define OSD1_ALCK	    0x0B8

#define OSD2_CONFIG	    0x0C0
#define OSD2_POS	    0x0C4
#define OSD2_DIM	    0x0C8
#define OSD2_TPOS	    0x0CC
#define OSD2_TDIM	    0x0D0
#define OSD2_TPIXEL	    0x0D4
#define OSD2_ALCK	    0x0D8

#define OSD0_LUT	    0x400
#define OSD1_LUT	    0x800
#define OSD2_LUT	    0xC00

#define DMA0_CONFIG	    0x100
#define DMA0_BADDR0	    0x104
#define DMA0_BADDR1	    0x108
#define DMA0_STRIDE	    0x10C
#define DMA0_BSIZE	    0x110
#define DMA0_BCOUNT	    0x114
#define DMA0_TPOS	    0x118
#define DMA0_TDIM	    0x11C

#define DMA1_CONFIG	    0x120
#define DMA1_BADDR0	    0x124
#define DMA1_BADDR1	    0x128
#define DMA1_STRIDE	    0x12C
#define DMA1_BSIZE	    0x130
#define DMA1_BCOUNT	    0x134
#define DMA1_TPOS	    0x138
#define DMA1_TDIM	    0x13C

#define DMA2_CONFIG	    0x140
#define DMA2_BADDR0	    0x144
#define DMA2_BADDR1	    0x148
#define DMA2_STRIDE	    0x14C
#define DMA2_BSIZE	    0x150
#define DMA2_BCOUNT	    0x154
#define DMA2_TPOS	    0x158
#define DMA2_TDIM	    0x15C

#define DMA3_CONFIG	    0x160
#define DMA3_BADDR0	    0x164
#define DMA3_BADDR1	    0x168
#define DMA3_STRIDE	    0x16C
#define DMA3_BSIZE	    0x170
#define DMA3_BCOUNT	    0x174
#define DMA3_TPOS	    0x178
#define DMA3_TDIM	    0x17C

#define DMA4_CONFIG	    0x180
#define DMA4_BADDR0	    0x184
#define DMA4_BADDR1	    0x188
#define DMA4_STRIDE	    0x18C
#define DMA4_BSIZE	    0x190
#define DMA4_BCOUNT	    0x194
#define DMA4_TPOS	    0x198
#define DMA4_TDIM	    0x19C

#define DMA5_CONFIG	    0x1A0
#define DMA5_BADDR0	    0x1A4
#define DMA5_BADDR1	    0x1A8
#define DMA5_STRIDE	    0x1AC
#define DMA5_BSIZE      0x1B0
#define DMA5_BCOUNT	    0x1B4
#define DMA5_TPOS	    0x1B8
#define DMA5_TDIM	    0x1BC

#define DMA6_CONFIG	    0x1C0
#define DMA6_BADDR0	    0x1C4
#define DMA6_BADDR1	    0x1C8
#define DMA6_STRIDE	    0x1CC
#define DMA6_BSIZE	    0x1D0
#define DMA6_BCOUNT	    0x1D4
#define DMA6_TPOS	    0x1D8
#define DMA6_TDIM	    0x1DC

#define DMA7_CONFIG	    0x1E0
#define DMA7_BADDR0	    0x1E4
#define DMA7_BADDR1	    0x1E8
#define DMA7_STRIDE	    0x1EC
#define DMA7_BSIZE	    0x1F0
#define DMA7_BCOUNT	    0x1F4
#define DMA7_TPOS	    0x1F8
#define DMA7_TDIM	    0x1FC

#define DMA8_CONFIG	    0x200
#define DMA8_BADDR0	    0x204
#define DMA8_BADDR1	    0x208
#define DMA8_STRIDE	    0x20C
#define DMA8_BSIZE	    0x210
#define DMA8_BCOUNT	    0x214
#define DMA8_TPOS	    0x218
#define DMA8_TDIM	    0x21C

#define DMA9_CONFIG	    0x220
#define DMA9_BADDR0	    0x224
#define DMA9_BADDR1	    0x228
#define DMA9_STRIDE	    0x22C
#define DMA9_BSIZE	    0x230
#define DMA9_BCOUNT	    0x234
#define DMA9_TPOS	    0x238
#define DMA9_TDIM	    0x23C

#endif //__OSDM_REGS_OFFSET_H
