

#define ILI9325_SET_REGISTER_WRITE  0x30
#define ILI9325_REGISTER_WRITE      0x20
#define ILI9325_REGISTER_READ       0x00
#define ILI9325_BPP                 16

/* ILI9325 Internal registers */

#define ILI9325_START_OSC       	0x00 /* Read this register to check 9325 is connected */
#define ILI9325_DRIVEROP_CTRL   	0x01
#define ILI9325_DRV_WAVE_CTRL   	0x02
#define ILI9325_ENTRY_MODE      	0x03
#define ILI9325_RESIZE_CTRL     	0x04
#define ILI9325_DISPLAY_CTRL1   	0x07
#define ILI9325_DISPLAY_CTRL2   	0x08
#define ILI9325_DISPLAY_CTRL3   	0x09
#define ILI9325_DISPLAY_CTRL4   	0x0A
#define ILI9325_RGB_DISP_CTRL1   	0x0C
#define ILI9325_FRAME_MARKER_POS        0x0D
#define ILI9325_RGB_DISP_CTRL2   	0x0F


#define ILI9325_POWER_CTRL1             0x10
#define ILI9325_POWER_CTRL2             0x11
#define ILI9325_POWER_CTRL3             0x12
#define ILI9325_POWER_CTRL4             0x13


#define ILI9325_HZ_GRAM_SET             0x20
#define ILI9325_VER_GRAM_SET            0x21


#define ILI9325_WRITE_DATA_GRAM         0x22

#define ILI9325_POWER_CTRL7             0x29
#define ILI9325_FRAME_RATE_CLR_CTRL     0x2B

#define ILI9325_GAMA_CTRL1              0x30
#define ILI9325_GAMA_CTRL2              0x31
#define ILI9325_GAMA_CTRL3              0x32
#define ILI9325_GAMA_CTRL4              0x35
#define ILI9325_GAMA_CTRL5              0x36
#define ILI9325_GAMA_CTRL6              0x37
#define ILI9325_GAMA_CTRL7              0x38
#define ILI9325_GAMA_CTRL8              0x39
#define ILI9325_GAMA_CTRL9              0x3C
#define ILI9325_GAMA_CTRL10             0x3D

#define ILI9325_HZ_ADDR_START           0x50
#define ILI9325_HZ_ADDR_END             0x51
#define ILI9325_VER_ADDR_START          0x52
#define ILI9325_VER_ADDR_END            0x53

#define ILI9325_DRIVER_OP_CTRL          0x60
#define ILI9325_BASE_IMG_DISP           0x61
#define ILI9325_VER_SCROLL_CTRL         0x6A

#define ILI9325_PART_IMG1_DISP_POS      0x80
#define ILI9325_PART_IMG1_AREA_START    0x81
#define ILI9325_PART_IMG1_AREA_END      0x82

#define ILI9325_PART_IMG2_DISP_POS      0x83
#define ILI9325_PART_IMG2_AREA_START    0x84
#define ILI9325_PART_IMG2_AREA_END      0x85

#define ILI9325_PANEL_INTF_CTRL1        0x90
#define ILI9325_PANEL_INTF_CTRL2        0x92
#define ILI9325_PANEL_INTF_CTRL3        0x95


#define ILI9325_OTP_VCM_PRG_CTRL        0xA1
#define ILI9325_OTP_VCM_STAT            0xA2
#define ILI9325_OTP_PRG_ID              0xA5

